import FormData from "form-data";
import { Logger } from "../logger";
import { SmartlingAuthApi } from "../auth/index";
export declare class SmartlingBaseApi {
    protected authApi: SmartlingAuthApi;
    protected entrypoint: string;
    protected defaultClientLibId: string;
    protected defaultClientVersion: string;
    protected clientLibId: string;
    protected clientLibVersion: string;
    protected logger: Logger;
    protected options: Record<string, unknown>;
    constructor(logger: Logger);
    setOptions(options: Record<string, unknown>): void;
    getClientLibId(): string;
    setClientLibId(clientLibId: string): void;
    getClientLibVersion(): string;
    setClientLibVersion(clientLibVersion: string): void;
    fetch(uri: string, options: Record<string, unknown>): Promise<Response>;
    ua(clientId: string, clientVersion: string): string;
    alterRequestData(uri: string, opts: Record<string, unknown>): Record<string, unknown>;
    getDefaultHeaders(headers?: Record<string, unknown>): Promise<Record<string, unknown>>;
    makeRequest(verb: string, uri: string, payload?: Record<string, unknown> | string | FormData, returnRawResponseBody?: boolean, headers?: Record<string, unknown>): Promise<any>;
}
