import { SmartlingAuthApi } from "../auth/index";
import { SmartlingBaseApi } from "../base/index";
import { Logger } from "../logger";
export declare class SmartlingApiClientBuilder {
    protected authApiClient: SmartlingAuthApi;
    protected userId: string;
    protected userSecret: string;
    protected baseSmartlingApiUrl: string;
    protected httpClientOptions: Record<string, unknown>;
    protected clientLibId: string;
    protected clientLibVersion: string;
    protected logger: Logger;
    setLogger(logger: Logger): SmartlingApiClientBuilder;
    setBaseSmartlingApiUrl(baseSmartlingApiUrl: string): SmartlingApiClientBuilder;
    setHttpClientConfiguration(httpClientOptions: Record<string, unknown>): SmartlingApiClientBuilder;
    setClientLibMetadata(clientLibId: string, clientLibVersion: string): SmartlingApiClientBuilder;
    authWithUserIdAndUserSecret(userId: string, userSecret: string): SmartlingApiClientBuilder;
    authWithAuthApiClient(authApiClient: SmartlingAuthApi): SmartlingApiClientBuilder;
    build<T extends SmartlingBaseApi>(constructor: new (baseUrl: string, authApi: SmartlingAuthApi, logger: any) => T): T;
}
